class Baum {// demonstriert Baumsortieren
            // 1. javac Baum.java
            // 2. java Test aufrufen

  private int  zahl;
  private Baum links, rechts;

  public static void einsortieren (int neu, Baum b) {
		if (b.links == null) {// b ist leer
			b.zahl = neu;
			b.links = new Baum();
			b.rechts = new Baum();
		} else {
			if (neu < b.zahl) {
				einsortieren (neu, b.links);
			} else {
				einsortieren (neu, b.rechts); 
			}
		} 
	}

  public static void ausgeben (Baum b) {
    if (b.links != null) {// b ist nicht leer
        ausgeben(b.links);
        	System.out.print(b.zahl+" ");
        ausgeben(b.rechts);
    }
  }
    

	public static void zeigen (Baum b) {
	  zeigen (b, 1);
	}

	public static void zeigen (Baum b, int tiefe) {
		if ( b.links != null ) {
			String tab = "";
			for (int i = 0; i <= 3*tiefe; i++) {
				tab = tab + " ";
			}
			zeigen (b.rechts, tiefe+1);
			System.out.println( tab + b.zahl);
			zeigen (b.links, tiefe+1);
		}
	}
}

class Test {

	public static void main (String args[]) {
		Baum wurzel = new Baum();
		int x;

		for (int i = 1; i < 11; i++) {
			x = (int)(Math.random()*100)+1;
			System.out.println(i+ ": " + x);
			Baum.einsortieren(x, wurzel);
		}
    System.out.println("Der Baum: ");
		Baum.zeigen(wurzel);
    System.out.println("Die Zahlen sortiert-->");
		Baum.ausgeben(wurzel);
    //for (int i = 0; i<1e8; i++){}
	}
}
/*
1: 33
2: 20
3: 13
4: 17
5: 72
6: 3
7: 64
8: 79
9: 21
10: 80
Der Baum:
             80
          79
       72
          64
    33
          21
       20
             17
          13
             3
Die Zahlen sortiert:
 3 13 17 20 21 33 64 72 79 80

*/